## mathgl 2.4.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project( MathGL2 )

set(mgl_clean_files )
set(MGL_DEP_LIBS)
add_definitions(-DMGL_SRC)

#add_definitions(-DZLIB_WINAPI)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${MathGL2_SOURCE_DIR}/scripts)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are:
		None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(MathGL_VERSION_MAJOR 2)
set(MathGL_VERSION_MINOR 4)
set(MathGL_PATCH_VERSION 4)
set(MathGL_VERSION ${MathGL_VERSION_MAJOR}.${MathGL_VERSION_MINOR}.${MathGL_PATCH_VERSION})
set(MathGL_SOVERSION 7.5.0)
string(TIMESTAMP MathGL_DATE UTC)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
	option(enable-lcov "Enable coverage." OFF)
	if(enable-lcov)
		include(CodeCoverage)
		APPEND_COVERAGE_COMPILER_FLAGS()
	endif(enable-lcov)
else(CMAKE_BUILD_TYPE STREQUAL "Debug")
	unset(enable-lcov CACHE)
endif(CMAKE_BUILD_TYPE STREQUAL "Debug")

#set(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE 1)
set(MathGL_INSTALL_LIB_DIR "lib" CACHE PATH "Installation directory for libraries")
set(MathGL_INSTALL_BIN_DIR "bin" CACHE PATH "Installation directory for executables")
set(MathGL_INSTALL_INCLUDE_DIR "include" CACHE PATH "Installation directory for headers")
if(WIN32 AND NOT CYGWIN)
  set(DEF_INSTALL_CMAKE_DIR cmake)
else()
  set(DEF_INSTALL_CMAKE_DIR lib/cmake/mathgl)
endif()
set(MathGL_INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")
# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE CMAKE)
  set(var MathGL_INSTALL_${p}_DIR)
  if(NOT IS_ABSOLUTE "${${var}}")
    set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
  endif()
endforeach()

macro(mgl_po_src)
    set(l_files )
    foreach(src_file ${ARGN})
        get_filename_component(fp ${src_file} ABSOLUTE)
        file(RELATIVE_PATH rel ${CMAKE_SOURCE_DIR} ${fp})
        list(APPEND l_files "${rel}")
    endforeach(src_file ${ARGN})
    set(po_files ${po_files} ${l_files} PARENT_SCOPE)
endmacro(mgl_po_src)

function(mgl_add_lib mgl_tmp_lib)
       if(${mgl_tmp_lib} MATCHES mgl)
               set(mgllib mgl)
               set(mgllib2 mgl2)
       else(${mgl_tmp_lib} MATCHES mgl)
               set(mgllib mgl-${mgl_tmp_lib})
               set(mgllib2 mgl2-${mgl_tmp_lib})
       endif(${mgl_tmp_lib} MATCHES mgl)
       set(mgl_src_lst ${ARGV})
       list(REMOVE_AT mgl_src_lst 0)
       add_library(${mgllib} SHARED ${mgl_src_lst})
       add_library(${mgllib}-static STATIC ${mgl_src_lst})
       set_target_properties(${mgllib} PROPERTIES SOVERSION ${MathGL_SOVERSION})
       set_target_properties(${mgllib} PROPERTIES DEFINE_SYMBOL "mgl_EXPORTS")
       set_target_properties(${mgllib} PROPERTIES C_VISIBILITY_PRESET hidden)
       set_target_properties(${mgllib} PROPERTIES CXX_VISIBILITY_PRESET hidden)
       set_target_properties(${mgllib} PROPERTIES VISIBILITY_INLINES_HIDDEN 1)
       target_compile_definitions(${mgllib}-static PUBLIC MGL_STATIC_DEFINE)
       if(MSVC)
	   set(mgl_lib_static "-static")
           if(CMAKE_BUILD_TYPE STREQUAL "Debug")
               set(mgl_lib_end "d")
	   else(CMAKE_BUILD_TYPE STREQUAL "Debug")
               set(mgl_lib_end)
           endif(CMAKE_BUILD_TYPE STREQUAL "Debug")
       elseif(MSVC)
	   set(mgl_lib_static)
           set_target_properties(${mgllib} PROPERTIES CLEAN_DIRECT_OUTPUT 1)
	   set_target_properties(${mgllib}-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
       endif(MSVC)
       if(enable-mgl2)
               set_target_properties(${mgllib} PROPERTIES OUTPUT_NAME "${mgllib2}${mgl_lib_end}")
               set_target_properties(${mgllib}-static PROPERTIES OUTPUT_NAME "${mgllib2}${mgl_lib_static}${mgl_lib_end}")
       else(enable-mgl2)
               set_target_properties(${mgllib} PROPERTIES OUTPUT_NAME "${mgllib}${mgl_lib_end}")
               set_target_properties(${mgllib}-static PROPERTIES OUTPUT_NAME "${mgllib}${mgl_lib_static}${mgl_lib_end}")
       endif(enable-mgl2)

       install(
               TARGETS ${mgllib} ${mgllib}-static
               EXPORT MathGLTargets
               RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
               ARCHIVE DESTINATION ${MathGL_INSTALL_LIB_DIR}
               LIBRARY DESTINATION ${MathGL_INSTALL_LIB_DIR}
       )
endfunction(mgl_add_lib mgl_tmp_lib)

MACRO(MGL_DEPENDENT_OPTION option doc default depends1 force1 depends2 force2)
  IF(${option}_ISSET MATCHES "^${option}_ISSET$")
    SET(${option}_AVAILABLE 1)
    IF(${force1})
    FOREACH(d ${depends1})
      STRING(REGEX REPLACE " +" ";" CMAKE_DEPENDENT_OPTION_DEP "${d}")
      IF(${CMAKE_DEPENDENT_OPTION_DEP})
      ELSE(${CMAKE_DEPENDENT_OPTION_DEP})
          SET(${option}_AVAILABLE 0)
          SET(depends1_AVAILABLE 1)
      ENDIF(${CMAKE_DEPENDENT_OPTION_DEP})
    ENDFOREACH(d)
    ENDIF(${force1})
    IF(${force2})
    FOREACH(d ${depends2})
      STRING(REGEX REPLACE " +" ";" CMAKE_DEPENDENT_OPTION_DEP "${d}")
      IF(${CMAKE_DEPENDENT_OPTION_DEP})
      ELSE(${CMAKE_DEPENDENT_OPTION_DEP})
          SET(${option}_AVAILABLE 0)
          SET(depends2_AVAILABLE 1)
      ENDIF(${CMAKE_DEPENDENT_OPTION_DEP})
    ENDFOREACH(d)
    ENDIF(${force2})
    IF(${option}_AVAILABLE)
      OPTION(${option} "${doc}" "${default}")
      SET(${option} "${${option}}" CACHE BOOL "${doc}" FORCE)
    ELSE(${option}_AVAILABLE)
      IF(${option} MATCHES "^${option}$")
      ELSE(${option} MATCHES "^${option}$")
        SET(${option} "${${option}}" CACHE INTERNAL "${doc}")
      ENDIF(${option} MATCHES "^${option}$")
        IF(depends1_AVAILABLE)
          SET(${option} OFF)
        ELSEIF(depends2_AVAILABLE)
          SET(${option} ON)
        ENDIF(depends1_AVAILABLE)
    ENDIF(${option}_AVAILABLE)
  ELSE(${option}_ISSET MATCHES "^${option}_ISSET$")
    SET(${option} "${${option}_ISSET}")
  ENDIF(${option}_ISSET MATCHES "^${option}_ISSET$")
ENDMACRO(MGL_DEPENDENT_OPTION)
include(CMakeDependentOption)

string(TIMESTAMP MGL_NIGHT "%d.%m.%y")

if(WIN32)
	option(enable-dep-dll "Enable copying off all dependent dll libraries to the install directory" OFF)
endif(WIN32)

option(enable-double "Enable double precision in MathGL library" ON)
option(enable-mpi "Enable mpi")
option(enable-opengl "Enable OpenGL support" ON)
option(enable-all-docs "Enable all documentation building")
#option(enable-doc "Enable documentation building")
option(enable-all "Enable all core features")
option(enable-all-widgets "Enable all Widgets")
option(enable-all-swig "Enable all SWIG based interfaces")
option(enable-rvalue "Enable move constructor support (need C++11)" OFF)
option(enable-pthread "Enable POSIX threads support" OFF)
if(MSVC)
	option(enable-pthr-widget "Enable POSIX threads for widgets" OFF)
else(MSVC)
	option(enable-pthr-widget "Enable POSIX threads for widgets" ON)
endif(MSVC)
option(enable-openmp "Enable OpenMP support" ON)
option(disable-C99complex "Enable C99 complex number support" OFF)

if(enable-pthread AND enable-openmp)
	message(SEND_ERROR "You can't enable POSIX threads and OpenMP at the same time!")
endif(enable-pthread AND enable-openmp)

option(enable-lgpl "Enable only LGPL part of MathGL")
option(enable-mgl2 "Use names 'libmgl2-*' instead of 'libmgl-*'")
option(enable-ltdl "Enable loading modules support")
option(enable-doc-site "Enable HTML documentation for website")
#CMAKE_DEPENDENT_OPTION(enable-doc-site "Enable HTML documentation for website" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-html "Enable HTML documentation" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-info "Enable INFO documentation" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-pdf-ru "Enable Russian PDF documentation" OFF "NOT enable-all-docs" ON)
CMAKE_DEPENDENT_OPTION(enable-doc-pdf-en "Enable English PDF documentation" OFF "NOT enable-all-docs" ON)
#CMAKE_DEPENDENT_OPTION(enable-doc-prc "Enable PDF samples for HTML docs" OFF "NOT enable-all-docs" ON)
#CMAKE_DEPENDENT_OPTION(enable-doc-json "Enable JSON samples for HTML docs" OFF "NOT enable-all-docs" ON)
option(enable-texi2html "Use texi2html (obsolete package) instead of texi2any" OFF)
CMAKE_DEPENDENT_OPTION(enable-mgltex "Enable installation of mgltex package (MGL scripts in LATEX document)" OFF "NOT enable-lgpl" OFF)

CMAKE_DEPENDENT_OPTION(enable-zlib "Enable zlib support" ON "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-png "Enable png support" ON "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-jpeg "Enable jpeg support" OFF "NOT enable-all" ON)
MGL_DEPENDENT_OPTION(enable-gsl "Enable gsl support" OFF "NOT enable-lgpl" ON "NOT enable-all" ON)
MGL_DEPENDENT_OPTION(enable-hdf4 "Enable hdf4 support" OFF "NOT enable-lgpl" ON "NOT enable-all" ON)
MGL_DEPENDENT_OPTION(enable-hdf5 "Enable hdf5 support" OFF "NOT enable-lgpl" ON "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-pdf "Enable pdf support" OFF "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-gif "Enable gif support" OFF "NOT enable-all" ON)
CMAKE_DEPENDENT_OPTION(enable-glut "Enable glut support" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-fltk "Enable fltk widget" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-wx "Enable wxWidget widget" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-qt4 "Enable Qt4 widget" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-qt4asqt "Set Qt4 as default libmgl-qt" OFF "enable-qt4" OFF)
CMAKE_DEPENDENT_OPTION(enable-qt5 "Enable Qt5 widget" OFF "NOT enable-all-widgets" ON)
CMAKE_DEPENDENT_OPTION(enable-qt5asqt "Set Qt5 as default libmgl-qt" OFF "enable-qt5" OFF)

# msvc fwprintf print char* for the specifier of "%s" format
if(MSVC AND MSVC_VERSION GREATER 1899)
	SET(CMAKE_CXX_FLAGS "/EHsc -D_CRT_STDIO_ISO_WIDE_SPECIFIERS ${CMAKE_CXX_FLAGS}")
	SET(CMAKE_C_FLAGS "-D_CRT_STDIO_ISO_WIDE_SPECIFIERS ${CMAKE_C_FLAGS}")
endif(MSVC AND MSVC_VERSION GREATER 1899)

include(CheckCXXSourceCompiles)

if(${CMAKE_SIZEOF_VOID_P} EQUAL 4)
	set(CMAKE_REQUIRED_FLAGS -msse2 -mfpmath=sse)
	CHECK_CXX_SOURCE_COMPILES("
		int main(void){}" mgl_sse)
	if(mgl_sse)
		SET(CMAKE_CXX_FLAGS "-msse2 -mfpmath=sse ${CMAKE_CXX_FLAGS}")
		SET(CMAKE_C_FLAGS "-msse2 -mfpmath=sse ${CMAKE_C_FLAGS}")
	endif(mgl_sse)
	unset(CMAKE_REQUIRED_FLAGS)
endif(${CMAKE_SIZEOF_VOID_P} EQUAL 4)

if(enable-qt4 OR enable-qt5)
	set(QT_ENABLED ON)
	if(enable-qt4asqt AND enable-qt5asqt)
		message(SEND_ERROR "You cannot make Qt4 and Qt5 as qt at the same time.")
	endif(enable-qt4asqt AND enable-qt5asqt)
	if(enable-qt4 AND NOT enable-qt5)
		set(enable-qt4asqt TRUE)
	endif(enable-qt4 AND NOT enable-qt5)
	if(enable-qt5 AND NOT enable-qt4)
		set(enable-qt5asqt TRUE)
	endif(enable-qt5 AND NOT enable-qt4)
# 	if(NOT enable-opengl)
# 		message(SEND_ERROR "You cannot build MathGL with Qt4 or Qt5 without OpenGL enabled.")
# 	endif(NOT enable-opengl)
endif(enable-qt4 OR enable-qt5)

CMAKE_DEPENDENT_OPTION(enable-json-sample "Enable JSON sample (WebKit variant is the default)." ON "QT_ENABLED" OFF)
CMAKE_DEPENDENT_OPTION(enable-json-sample-we "Enable JSON sample (WebEngine variant)." OFF "enable-json-sample" OFF)
MGL_DEPENDENT_OPTION(enable-python "Enable python interface" OFF "NOT enable-lgpl" ON "NOT enable-all-swig" ON)
MGL_DEPENDENT_OPTION(enable-lua "Enable Lua (v.5.1) interface" OFF "NOT enable-lgpl" ON "NOT enable-all-swig" ON)
MGL_DEPENDENT_OPTION(enable-octave "Enable octave interface" OFF "NOT enable-lgpl" ON "NOT enable-all-swig" ON)
MGL_DEPENDENT_OPTION(enable-octave-install "Octave interface will install for all users" ON "NOT enable-lgpl" ON "NOT enable-all-swig" ON)

include_directories( ${MathGL2_SOURCE_DIR}/include ${MathGL2_BINARY_DIR}/include)
set(MGL_INCLUDE_PATH "${CMAKE_INSTALL_PREFIX}/include/mgl2")
set(MGL_CGI_PATH_INSTALL "lib/cgi-bin" CACHE STRING "Set CGI install directory")
#set(MGL_CGI_PATH_INSTALL "share/mathgl" CACHE STRING "Set CGI install directory")

=== examples/CMakeLists.txt ===
file(COPY ${CMAKE_SOURCE_DIR}/examples/iris.dat DESTINATION ${CMAKE_BINARY_DIR}/examples)
file(COPY ${CMAKE_SOURCE_DIR}/examples/Equirectangular-projection.jpg DESTINATION ${CMAKE_BINARY_DIR}/examples)
file(COPY ${CMAKE_SOURCE_DIR}/examples/samples.cpp DESTINATION ${CMAKE_BINARY_DIR}/examples)
file(COPY ${CMAKE_SOURCE_DIR}/examples/wnd_samples.cpp DESTINATION ${CMAKE_BINARY_DIR}/examples)
add_executable(mgl_example wnd_samples.cpp full_test.cpp samples.cpp)
target_link_libraries(mgl_example mgl-static ${getopt_lib-static})
if(CMAKE_BUILD_TYPE STREQUAL "Debug" AND CMAKE_COMPILER_IS_GNUCXX AND enable-lcov)
	setup_target_for_coverage(
	    NAME mgl_coverage
	    EXECUTABLE $<TARGET_FILE:mgl_example> -mgl
	    DEPENDENCIES mgl_example
	)
endif(CMAKE_BUILD_TYPE STREQUAL "Debug" AND CMAKE_COMPILER_IS_GNUCXX AND enable-lcov)

if(MGL_HAVE_FLTK)
	include_directories(${FLTK_INCLUDE_DIR})
	add_executable(mgl_fltk_example wnd_samples.cpp fltk_example.cpp)
	target_link_libraries(mgl_fltk_example mgl-fltk)
endif(MGL_HAVE_FLTK)

if(MGL_HAVE_GLUT)
	add_executable(mgl_glut_example wnd_samples.cpp glut_example.cpp)
	target_link_libraries(mgl_glut_example mgl-glut)
endif(MGL_HAVE_GLUT)

if(MGL_HAVE_WX)
	include(${wxWidgets_USE_FILE})
	add_executable(mgl_wx_example wnd_samples.cpp wx_example.cpp)
	target_link_libraries(mgl_wx_example mgl-wx)
endif(MGL_HAVE_WX)

if(QT_ENABLED)
	add_executable(mgl_qt_example wnd_samples.cpp qt_example.cpp)
	if(enable-qt5)
		include(../scripts/qt5.cmake)
		target_link_libraries(mgl_qt_example mgl-qt5)
	else(enable-qt5)
		include(../scripts/qt4.cmake)
		target_link_libraries(mgl_qt_example mgl-qt4)
	endif(enable-qt5)
	
	if(MGL_HAVE_OPENGL)
		add_executable(mgl_qgl_example wnd_samples.cpp qgl_example.cpp)
		if(enable-qt5)
			target_link_libraries(mgl_qgl_example mgl ${MGL_QT5_LIBS})
		else(enable-qt5)
			target_link_libraries(mgl_qgl_example mgl ${MGL_QT4_LIBS})
		endif(enable-qt5)
	endif(MGL_HAVE_OPENGL)
endif(QT_ENABLED)

if(MGL_HAVE_LTDL)
	add_library(mgl_module MODULE mgl_module.cpp)
	target_link_libraries(mgl_module mgl)	# for compatibility with win32
endif(MGL_HAVE_LTDL)

if(MGL_HAVE_MPI)
	add_executable(mgl_mpi_example mpi_test.cpp)
	target_link_libraries(mgl_mpi_example mgl-mpi mgl ${MPI_LIBRARIES})
	target_include_directories(mgl_mpi_example SYSTEM PUBLIC ${MPI_CXX_INCLUDE_PATH})
endif(MGL_HAVE_MPI)

=== include/CMakeLists.txt ===
configure_file(${MathGL2_SOURCE_DIR}/include/config.h.in ${MathGL2_BINARY_DIR}/include/mgl2/config.h)
configure_file(${MathGL2_SOURCE_DIR}/include/build.h.in ${MathGL2_BINARY_DIR}/include/mgl2/build.h)

install(DIRECTORY mgl2/ DESTINATION ${MGL_INCLUDE_PATH}
                        PATTERN ".svn" EXCLUDE
                        PATTERN "fltk.h" EXCLUDE
                        PATTERN "glut.h" EXCLUDE
                        PATTERN "wx.h" EXCLUDE
                        PATTERN "qt.h" EXCLUDE
                        PATTERN "qmathgl.h" EXCLUDE
                        PATTERN "window.h" EXCLUDE
                        PATTERN "*old.h" EXCLUDE
                        PATTERN "*~" EXCLUDE
                        PATTERN "*.fs"
                        PATTERN "*.pas"
                        PATTERN "*.h")

install(FILES ${MathGL2_BINARY_DIR}/include/mgl2/config.h DESTINATION ${MGL_INCLUDE_PATH})
if(MGL_HAVE_FLTK)
	install(FILES mgl2/fltk.h DESTINATION ${MGL_INCLUDE_PATH})
endif(MGL_HAVE_FLTK)
if(MGL_HAVE_GLUT)
	install(FILES mgl2/glut.h DESTINATION ${MGL_INCLUDE_PATH})
endif(MGL_HAVE_GLUT)
if(MGL_HAVE_WX)
	install(FILES mgl2/wx.h DESTINATION ${MGL_INCLUDE_PATH})
endif(MGL_HAVE_WX)
if(MGL_HAVE_QT)
	install(FILES mgl2/qt.h mgl2/qmathgl.h DESTINATION ${MGL_INCLUDE_PATH})
endif(MGL_HAVE_QT)

#if(MGL_HAVE_FLTK AND MGL_HAVE_WX AND MGL_HAVE_QT)
if(MGL_HAVE_FLTK AND MGL_HAVE_QT AND MGL_HAVE_WX)
	install(FILES mgl2/window.h DESTINATION ${MGL_INCLUDE_PATH})
#endif(MGL_HAVE_FLTK AND MGL_HAVE_WX AND MGL_HAVE_QT)
endif(MGL_HAVE_FLTK AND MGL_HAVE_QT AND MGL_HAVE_WX)

=== lang/CMakeLists.txt ===
set(src_imp_dep
../include/mgl2/type.h
../include/mgl2/data.h
../include/mgl2/mgl.h
mgl.i
data.i
type.i
)

set(mgl_clean_files "")

SET_SOURCE_FILES_PROPERTIES(mathgl.i numpy.i PROPERTIES CPLUSPLUS ON)

FIND_PACKAGE(SWIG)
if(NOT SWIG_FOUND)
	message(SEND_ERROR "Couldn't find swig needed for interfaces compiling.")
endif(NOT SWIG_FOUND)
INCLUDE(${SWIG_USE_FILE})

if(enable-python)
	set(Python_ADDITIONAL_VERSIONS 2.7)
	FIND_PACKAGE(PythonInterp)
	if(NOT PYTHONINTERP_FOUND)
		message(SEND_ERROR "Couldn't find python interpreter.")
	endif(NOT PYTHONINTERP_FOUND)
	FIND_PACKAGE(PythonLibs)
	if(NOT PYTHONLIBS_FOUND)
		message(SEND_ERROR "Couldn't find python development libraries.")
	endif(NOT PYTHONLIBS_FOUND)
	execute_process(
		COMMAND ${PYTHON_EXECUTABLE} -c "import numpy; print numpy.get_include()"
		OUTPUT_VARIABLE NUMPY_INCLUDE_PATH
		RESULT_VARIABLE NUMPY_ERR
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)
	if(NOT NUMPY_INCLUDE_PATH)
		message(SEND_ERROR "Couldn't find numpy.")
	endif(NOT NUMPY_INCLUDE_PATH)

	include_directories(${PYTHON_INCLUDE_DIR}  ${NUMPY_INCLUDE_PATH})
	execute_process(
		COMMAND ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(prefix='${CMAKE_INSTALL_PREFIX}')"
		OUTPUT_VARIABLE MGL_PYTHON_SITE_PACKAGES
		OUTPUT_STRIP_TRAILING_WHITESPACE)
	set(SWIG_MODULE_mathgl_EXTRA_DEPS numpy.i ${src_imp_dep})
	if(${CMAKE_VERSION} VERSION_LESS "3.8.0") 
		SWIG_ADD_MODULE(mathgl python mathgl.i)
	else(${CMAKE_VERSION} VERSION_LESS "3.8.0")
		SWIG_ADD_LIBRARY(mathgl LANGUAGE python SOURCES mathgl.i)
	endif(${CMAKE_VERSION} VERSION_LESS "3.8.0")
	SWIG_LINK_LIBRARIES(mathgl mgl ${PYTHON_LIBRARIES})
	set_target_properties(_mathgl PROPERTIES BUILD_WITH_INSTALL_RPATH ON)
	add_custom_command(OUTPUT mathgl.pyc
		COMMAND ${PYTHON_EXECUTABLE}
		ARGS -c \"from py_compile import compile\; compile('mathgl.py') \"
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lang
		DEPENDS _mathgl
	)
	add_custom_target(mgl_python_module ALL DEPENDS _mathgl mathgl.pyc)

	install(FILES ${MathGL2_BINARY_DIR}/lang/mathgl.py ${MathGL2_BINARY_DIR}/lang/mathgl.pyc DESTINATION ${MGL_PYTHON_SITE_PACKAGES})
	install (TARGETS _mathgl LIBRARY DESTINATION ${MGL_PYTHON_SITE_PACKAGES})
	set(mgl_clean_files ${mgl_clean_files} mathgl.py)
endif(enable-python)

if(enable-lua)
	INCLUDE(FindLua51)
	if(NOT LUA51_FOUND)
		message(SEND_ERROR "Couldn't find Lua 5.1 library.")
	endif(NOT LUA51_FOUND)

	include_directories(${LUA_INCLUDE_DIR})
	set(SWIG_MODULE_mgl-lua_EXTRA_DEPS numpy.i ${src_imp_dep})
	if(${CMAKE_VERSION} VERSION_LESS "3.8.0") 
		SWIG_ADD_MODULE(mgl-lua lua mathgl.i)
	else(${CMAKE_VERSION} VERSION_LESS "3.8.0")
		SWIG_ADD_LIBRARY(mgl-lua LANGUAGE lua SOURCES mathgl.i)
	endif(${CMAKE_VERSION} VERSION_LESS "3.8.0")
	SWIG_LINK_LIBRARIES(mgl-lua mgl ${LUA_LIBRARIES})
	set_target_properties(mgl-lua PROPERTIES PREFIX "" BUILD_WITH_INSTALL_RPATH ON)

	install (TARGETS mgl-lua LIBRARY DESTINATION ${MathGL_INSTALL_LIB_DIR})
endif(enable-lua)

if(enable-octave)
	find_program(oct_prog octave-config)
	if(NOT oct_prog)
		message(SEND_ERROR "Couldn't find octave-config needed for octave interfaces compiling.")
	endif(NOT oct_prog)
	find_program(oct_exec octave)
	if(NOT oct_exec)
		message(SEND_ERROR "Couldn't find octave needed for octave interfaces compiling.")
	endif(NOT oct_exec)
	find_program(oct_mk mkoctfile)
	if(NOT oct_mk)
		message(SEND_ERROR "Couldn't find mkoctfile needed for octave interfaces compiling.")
	endif(NOT oct_mk)
	find_program(oct_tar tar)
	if(NOT oct_tar)
		message(SEND_ERROR "Couldn't find tar needed for octave interfaces creation.")
	endif(NOT oct_tar)

	execute_process(COMMAND ${oct_prog} -p CANONICAL_HOST_TYPE
	OUTPUT_VARIABLE oct_host
	OUTPUT_STRIP_TRAILING_WHITESPACE)
	execute_process(COMMAND ${oct_prog} -p API_VERSION
	OUTPUT_VARIABLE oct_api
	OUTPUT_STRIP_TRAILING_WHITESPACE)
	execute_process(COMMAND ${oct_mk} -p INCFLAGS
	OUTPUT_VARIABLE oct_inc
	OUTPUT_STRIP_TRAILING_WHITESPACE)
	separate_arguments(oct_inc)
message(STATUS "${oct_prog} ${oct_host} ${oct_api}")
	set(oct_arch ${oct_host}-${oct_api})
	set(pkg_name mathgl)
	set(mgl_pkg_dir ${MathGL2_BINARY_DIR}/lang/${pkg_name}/inst/${oct_arch})

	add_compile_options(${oct_inc})
	SET(SWIG_MODULE_mgl-oct_EXTRA_DEPS numpy.i ${src_imp_dep})
	if(${CMAKE_VERSION} VERSION_LESS "3.8.0") 
		SWIG_ADD_MODULE(mgl-oct octave mathgl.i)
	else(${CMAKE_VERSION} VERSION_LESS "3.8.0")
		SWIG_ADD_LIBRARY(mgl-oct LANGUAGE octave SOURCES mathgl.i)
	endif(${CMAKE_VERSION} VERSION_LESS "3.8.0")
	SWIG_LINK_LIBRARIES(mgl-oct mgl)
	set_target_properties(mgl-oct PROPERTIES OUTPUT_NAME mathgl PREFIX "" SUFFIX ".oct" BUILD_WITH_INSTALL_RPATH ON)
	add_custom_command(OUTPUT mathgl.tar.gz
		COMMAND ${CMAKE_COMMAND} -E make_directory ${mgl_pkg_dir}
		COMMAND ${CMAKE_COMMAND} -E copy ${MathGL2_SOURCE_DIR}/COPYING ${MathGL2_BINARY_DIR}/lang/${pkg_name}
		COMMAND ${CMAKE_COMMAND} -E copy ${MathGL2_SOURCE_DIR}/lang/DESCRIPTION ${MathGL2_BINARY_DIR}/lang/${pkg_name}
		COMMAND ${CMAKE_COMMAND} -E copy ${MathGL2_SOURCE_DIR}/lang/INDEX ${MathGL2_BINARY_DIR}/lang/${pkg_name}
		COMMAND ${CMAKE_COMMAND} -E copy ${MathGL2_SOURCE_DIR}/lang/PKG_ADD_template ${MathGL2_BINARY_DIR}/lang/${pkg_name}
		COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:mgl-oct> ${mgl_pkg_dir}
		COMMAND ${oct_tar} cpzf mathgl.tar.gz ${pkg_name}
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lang
		DEPENDS mgl-oct
	)
	add_custom_target(mgl_octave_module ALL DEPENDS mathgl.tar.gz)

	install(FILES ${CMAKE_BINARY_DIR}/lang/mathgl.tar.gz DESTINATION ${MGL_DATA_PATH})
	if(enable-octave-install)
		install(CODE "execute_process(
			COMMAND ${oct_exec} -q --eval \"pkg install mathgl.tar.gz\"
			WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lang )")
	endif(enable-octave-install)
	set(mgl_clean_files ${mgl_clean_files} mathgl)
endif(enable-octave)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${mgl_clean_files}")

=== scripts/CMakeLists.txt ===
if(enable-dep-dll)
	if(enable-qt5)
		find_package(Qt5Gui QUIET)
		if(Qt5Gui_FOUND)
			get_target_property(mgl_qt_loc Qt5::QWindowsIntegrationPlugin LOCATION)
		endif(Qt5Gui_FOUND)
	endif(enable-qt5)

	install(CODE "SET(mgl_qt_loc \"${mgl_qt_loc}\")")
	install(CODE "SET(CMAKE_INSTALL_PREFIX \"${CMAKE_INSTALL_PREFIX}\")")
	install(SCRIPT install-deps.cmake)
endif(enable-dep-dll)

if(WIN32)
   set(dest ${CMAKE_INSTALL_PREFIX})
	install(FILES ${CMAKE_SOURCE_DIR}/scripts/FindMathGL2.cmake DESTINATION ${CMAKE_INSTALL_PREFIX} RENAME mathgl2-config.cmake)
else(WIN32)
   set(dest ${MathGL_INSTALL_LIB_DIR}/cmake/mathgl2/)
	install(FILES ${CMAKE_SOURCE_DIR}/scripts/FindMathGL2.cmake DESTINATION ${MathGL_INSTALL_LIB_DIR}/cmake/mathgl2/ RENAME mathgl2-config.cmake)
endif(WIN32)

#export(TARGETS MathGLTargets FILE "${PROJECT_BINARY_DIR}/MathGL2Targets.cmake")
export(PACKAGE MathGL2)

configure_file(MathGLConfig.cmake.in "${MathGL2_BINARY_DIR}/MathGL2Config.cmake" @ONLY)
configure_file(MathGLConfigVersion.cmake.in "${MathGL2_BINARY_DIR}/MathGL2ConfigVersion.cmake" @ONLY)

install(FILES
	"${MathGL2_BINARY_DIR}/MathGL2Config.cmake"
	"${MathGL2_BINARY_DIR}/MathGL2ConfigVersion.cmake"
	DESTINATION "${MathGL_INSTALL_CMAKE_DIR}" COMPONENT dev)

install(EXPORT MathGLTargets DESTINATION "${MathGL_INSTALL_CMAKE_DIR}" COMPONENT dev)

=== src/CMakeLists.txt ===
set(mgl_src
	addon.cpp axis.cpp base_cf.cpp base.cpp canvas_cf.cpp canvas.cpp cont.cpp crust.cpp
	complex.cpp complex_ex.cpp complex_io.cpp fft.cpp data_gr.cpp
	data.cpp data_io.cpp data_ex.cpp data_png.cpp
	export_2d.cpp export_3d.cpp eval.cpp evalp.cpp export.cpp
	fit.cpp font.cpp obj.cpp other.cpp parser.cpp pde.cpp pixel.cpp pixel_gen.cpp
	plot.cpp prim.cpp surf.cpp vect.cpp volume.cpp evalc.cpp
	s_hull/s_hull_pro.cpp window.cpp fractal.cpp
	exec_dat.cpp exec_gr.cpp exec_set.cpp exec_prm.cpp c2mdual.c
)

set(mgl_hdr
	../include/mgl2/base_cf.h	../include/mgl2/fit.h		../include/mgl2/plot.h
	../include/mgl2/base.h		../include/mgl2/prim.h		../include/mgl2/canvas_cf.h
	../include/mgl2/font.h		../include/mgl2/canvas.h	../include/mgl2/surf.h
	../include/mgl2/mgl_cf.h	../include/mgl2/type.h		${MathGL2_BINARY_DIR}/include/mgl2/config.h
${MathGL2_BINARY_DIR}/include/mgl2/dllexport.h	cont.hpp
	../include/mgl2/cont.h		../include/mgl2/mgl.h		../include/mgl2/vect.h
	../include/mgl2/data.h		../include/mgl2/volume.h	../include/mgl2/data_cf.h
	../include/mgl2/define.h	../include/mgl2/other.h		../include/mgl2/eval.h
	../include/mgl2/parser.h	../include/mgl2/addon.h		../include/mgl2/evalc.h
	s_hull/s_hull_pro.h			../include/mgl2/wnd.h		../include/mgl2/canvas_wnd.h
	../include/mgl2/thread.h	../include/mgl2/abstract.h	../include/mgl2/pde.h
#	tex_table.cc	 def_font.cc
)

if(MSVC)
	add_definitions(-DMGL_LIB_MSVC)
endif(MSVC)

if(MGL_HAVE_GSL2)
	add_definitions(-DMGL_HAVE_GSL2)
endif(MGL_HAVE_GSL2)

if(MGL_HAVE_PNG)
	set(prc_src prc/PRCbitStream.cc prc/PRCdouble.cc prc/oPRCFile.cc prc/writePRC.cc prc.cpp )
	set(prc_hdr prc/PRC.h prc/PRCbitStream.h prc/PRCdouble.h prc/oPRCFile.h prc/writePRC.h )

	set(mgl_src ${mgl_src} ${prc_src} )
	set(mgl_hdr ${mgl_hdr} ${prc_hdr} )
	include_directories(prc)
endif(MGL_HAVE_PNG)

if(MGL_HAVE_OPENGL)
	set(mgl_src ${mgl_src} opengl.cpp )
	set(mgl_hdr ${mgl_hdr} ../include/mgl2/opengl.h )
endif(MGL_HAVE_OPENGL)

include(GenerateExportHeader)
mgl_add_lib(mgl ${mgl_src} ${mgl_hdr})
generate_export_header(mgl EXPORT_FILE_NAME ../include/mgl2/dllexport.h)

target_link_libraries(mgl ${MGL_DEP_LIBS})
target_link_libraries(mgl-static ${MGL_DEP_LIBS})

mgl_po_src(${mgl_src} ${mgl_hdr})

if(MGL_HAVE_MPI)
	mgl_add_lib(mpi mpi.cpp ../include/mgl2/mpi.h)
	target_link_libraries(mgl-mpi ${MPI_LIBRARIES} )
	target_link_libraries(mgl-mpi-static ${MPI_LIBRARIES} )
	target_include_directories(mgl-mpi SYSTEM PUBLIC ${MPI_CXX_INCLUDE_PATH})
endif(MGL_HAVE_MPI)

install(FILES ${MathGL2_BINARY_DIR}/include/mgl2/dllexport.h DESTINATION ${MGL_INCLUDE_PATH})

=== utils/CMakeLists.txt ===
add_executable(make_pas make_pas.cpp)

add_executable(mgltask mgltask.cpp)
install(
	TARGETS mgltask
	EXPORT MathGLTargets
	RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
)

add_executable(mglconv mglconv.cpp)
if(MSVC)
set(link_type -static)
else(MSVC)
set(link_type)
endif(MSVC)
target_link_libraries(mglconv mgl${link_type} ${getopt_lib-static})
install(
	TARGETS mglconv
	EXPORT MathGLTargets
	RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
)

add_executable(mgl.cgi mglcgi.cpp)
target_link_libraries(mgl.cgi mgl-static)
install(
	TARGETS mgl.cgi
	EXPORT MathGLTargets
# should be /usr/lib/cgi-bin/
	RUNTIME DESTINATION ${MGL_CGI_PATH}
)

mgl_po_src(mglconv.cpp mglview.cpp mglcgi.cpp)

if(MGL_HAVE_FLTK)
	add_definitions(-DUSE_FLTK)
	add_executable(mglview mglview.cpp)
	target_link_libraries(mglview mgl-fltk ${getopt_lib-static} ${FLTK_LIBRARIES})
	install(
		TARGETS mglview
		EXPORT MathGLTargets
		RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
	)

else(MGL_HAVE_FLTK)
	if(QT_ENABLED)
		add_executable(mglview mglview.cpp)
		if(enable-qt5)
			include(../scripts/qt5.cmake)
			target_link_libraries(mglview mgl-qt5${link_type} ${getopt_lib-static} ${MGL_QT5_LIBS})
		else(enable-qt5)
			include(../scripts/qt4.cmake)
			target_link_libraries(mglview mgl-qt4${link_type} ${getopt_lib-static} ${MGL_QT4_LIBS})
		endif(enable-qt5)

		install(
			TARGETS mglview
			EXPORT MathGLTargets
			RUNTIME DESTINATION ${MathGL_INSTALL_BIN_DIR}
		)
	endif(QT_ENABLED)
endif(MGL_HAVE_FLTK)

=== widgets/CMakeLists.txt ===
include(GenerateExportHeader)

if(MSVC)
	add_definitions(-DMGL_LIB_MSVC)
endif(MSVC)

if(MGL_HAVE_FLTK)
	mgl_add_lib(fltk fltk.cpp  image.cpp  image.h ../include/mgl2/fltk.h ../include/mgl2/Fl_MathGL.h)
	target_include_directories(mgl-fltk SYSTEM PUBLIC ${FLTK_INCLUDE_DIR})
	target_include_directories(mgl-fltk-static SYSTEM PUBLIC ${FLTK_INCLUDE_DIR})
	target_link_libraries(mgl-fltk mgl ${FLTK_LIBRARIES})
	target_link_libraries(mgl-fltk-static mgl-static ${FLTK_LIBRARIES})
endif(MGL_HAVE_FLTK)

if(MGL_HAVE_GLUT)
	mgl_add_lib(glut glut.cpp ../include/mgl2/glut.h)
	target_include_directories(mgl-glut SYSTEM PUBLIC ${GLUT_INCLUDE_DIR})
	target_include_directories(mgl-glut-static SYSTEM PUBLIC ${GLUT_INCLUDE_DIR})
	target_link_libraries(mgl-glut mgl ${GLUT_LIBRARIES} ${OPENGL_LIBRARIES})
	target_link_libraries(mgl-glut-static mgl-static ${GLUT_LIBRARIES} ${OPENGL_LIBRARIES})
endif(MGL_HAVE_GLUT)

if(MGL_HAVE_WX)
	mgl_add_lib(wx wx.cpp ../include/mgl2/wx.h)
	include(${wxWidgets_USE_FILE})
	target_link_libraries(mgl-wx mgl ${wxWidgets_LIBRARIES})
	target_link_libraries(mgl-wx-static mgl-static ${wxWidgets_LIBRARIES})
endif(MGL_HAVE_WX)

add_subdirectory( qt4 )
add_subdirectory( qt5 )

mgl_po_src(fltk.cpp ../include/mgl2/fltk.h ../include/mgl2/Fl_MathGL.h glut.cpp ../include/mgl2/glut.h wx.cpp ../include/mgl2/wx.h qt.cpp ../include/mgl2/qt.h  ../include/mgl2/qmathgl.h)

=== win32-install-deps/CMakeLists.txt ===
if(enable-qt5)
	find_package(Qt5Gui QUIET)
	if(Qt5Gui_FOUND)
		get_target_property(mgl_qt_loc Qt5::QWindowsIntegrationPlugin LOCATION)
	endif(Qt5Gui_FOUND)
endif(enable-qt5)

install(CODE "SET(mgl_qt_loc \"${mgl_qt_loc}\")")
install(CODE "SET(CMAKE_INSTALL_PREFIX \"${CMAKE_INSTALL_PREFIX}\")")
install(SCRIPT install-deps.txt)

=== debian/changelog ===
mathgl (2.4.4-6) unstable; urgency=medium

  * Standards-Version: 4.5.0
  * Use dh-sequence-python3 rather than --with python3
  * Use swig rather than swig4.0. Closes: #952600

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 27 Feb 2020 09:37:10 +0000

mathgl (2.4.4-5) unstable; urgency=medium

  * Disable building of python2 module
  * Remove python-numpy from build dependencies (Closes: #943171)

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Sun, 08 Dec 2019 15:56:30 +0200

mathgl (2.4.4-4) unstable; urgency=medium

  [ Alastair McKinstry ]
  * Switch from obsolete texlive-generic-recommended  to texlive-plain-generic
    Closes: #941538
  * Filter format-security warnings which break autogenerated code
  * Standard-Version: 4.4.1.0

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 02 Oct 2019 19:23:33 +0100

mathgl (2.4.4-3) unstable; urgency=medium

  * Ack. previously fixed bugs. Closes: #696896, #908904
  * Rebuild against wxWidgets GTK3. Closes: #933430

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 31 Jul 2019 10:21:43 +0100

mathgl (2.4.4-2) unstable; urgency=medium

  [ Dimitrios Eftaxiopoulo ]
  * Remove unused fix_hdf5.patch
  * Remove d/compat file and use Build-Depends: debhelper-compat (= 12)
    in d/control

  [ Alastair McKinstry ]
  * overide dh_dwz of mips, mipsel archs as it causes FTBFS

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 29 Jul 2019 19:13:56 +0100

mathgl (2.4.4-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.4.0
  * Still need to B-D on python-numpy. Why?

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 15 Jul 2019 08:49:05 +0100

mathgl (2.4.3-1) unstable; urgency=medium

  * New upstream release
  * Now use debhelper 12
  * Enable OpenMP support. clang now supports this.
    - drop pthread.patch
  * Update VCS-* references to salsa.debian.org.
  * Standards-Version: 4.3.0
  * Simplify d/control Conflicts/Replaces, removing packages before oldstable
  * Drop Python2 module

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 25 Jun 2019 11:42:13 +0100

=== debian/control ===
Source: mathgl
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>,
  Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 12), 
 dh-sequence-python3,
 libltdl-dev, 
 libgsl-dev, 
 freeglut3-dev,
 libgl1-mesa-dev | libgl-dev, 
 libpng-dev, 
 libhdf5-dev, 
 libqt5opengl5-dev,
 libjpeg-dev, 
 libtiff-dev, 
 libfltk1.3-dev, 
 python3-dev, 
 python3-numpy, 
 qtwebengine5-dev [amd64 arm64 armhf i386 mipsel], 
 libwxgtk3.0-gtk3-dev,
 texinfo, 
 texlive, 
 texlive-plain-generic, 
 liblua5.1-dev, 
 libxcursor-dev,
 libgif-dev, 
 libfontconfig1-dev, 
 libqt5webkit5-dev,
 libhdf4-dev, 
 chrpath, 
 libxinerama-dev, 
 libxmu-dev, 
 libxi-dev, 
 libhpdf-dev,
 mpi-default-dev, 
 swig,
 cmake, 
 libxft-dev, 
 liboctave-dev,  
 fluid
Standards-Version: 4.5.0
Homepage: http://mathgl.sourceforge.net/doc_en/Main.html
Vcs-Git: https://salsa.debian.org/science-team/mathgl.git
Vcs-Browser: https://salsa.debian.org/science-team/mathgl

Package: mathgl
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl7.5.0 (= ${binary:Version})
Description: library for scientific graphs (utilities and examples)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains MathGL utilities and examples.

Package: udav
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl7.5.0 (= ${binary:Version})
Description: library for scientific graphs (window interface)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the udav window environment based on mathgl.

# Package: mathgl-doc-en
# Architecture: all
# Section: doc
# Depends: dpkg (>= 1.15.4) | install-info, ${misc:Depends}
# Replaces: mathgl-doc, mathgl-doc-ru
# Conflicts: mathgl-doc, mathgl-doc-ru
# Description: library for scientific graphs (English documentation)
#  A free cross-platform library of fast C++ routines for plotting data in up
#  to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
#  files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
#  MathGL can also be used in the console. There are interfaces to a set of
#  languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
#  .
#  This package contains the MathGL documentation in English.

Package: libmgl7.5.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data
Replaces: libmgl7.4.1
Conflicts: libmgl7.4.1
Description: library for scientific graphs (main runtime library)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the shared object files.

Package: libmgl-mpi7.5.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data
Replaces: libmgl-mpi7.4.1
Conflicts: libmgl-mpi7.4.1
Description: library for scientific graphs (mpi enhanced runtime library)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the, parallel interface enhanced, shared object 
 files.

Package: libmgl-wnd7.5.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data
Replaces: libmgl-fltk5, libmgl-wnd6, libmgl-qt5, libmgl-wx5, libmgl-wnd7.4.1
Conflicts: libmgl-fltk5, libmgl-wnd6, libmgl-qt5, libmgl-wx5, libmgl-wnd7.4.1
Description: library for scientific graphs (windows runtime library)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the window opening related shared object files based
 on Fltk, Qt and Wx.
 
Package: libmgl-glut7.5.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data
Replaces: libmgl-glut5, libmgl-glut6.0.0, libmgl-glut7.1.0, libmgl-glut7.2.0,
 libmgl-glut7.4.0, libmgl-glut7.4.1
Conflicts: libmgl-glut5, libmgl-glut6.0.0, libmgl-glut7.1.0, libmgl-glut7.2.0,
 libmgl-glut7.4.0, libmgl-glut7.4.1
Description: library for scientific graphs (glut interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the glut interface shared object files for window 
 opening.

Package: libmgl-qt5-7.5.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data
Replaces: libmgl-qt5, libmgl-qt7.1.0, libmgl-qt7.2.0, libmgl-qt7.4.0,
 libmgl-qt5-7.4.1
Conflicts: libmgl-qt5, libmgl-qt7.1.0, libmgl-qt7.2.0, libmgl-qt7.4.0,
 libmgl-qt5-7.4.1
Description: library for scientific graphs (Qt interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the Qt interface shared object files for window 
 opening.

Package: libmgl-fltk7.5.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data
Replaces: libmgl-fltk7.4.1
Conflicts: libmgl-fltk7.4.1
Description: library for scientific graphs (fltk interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the fltk interface shared object files for window 
 opening.

Package: libmgl-wx7.5.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data
Replaces: libmgl-wx7.4.1
Conflicts: libmgl-wx7.4.1
Description: library for scientific graphs (wx interface for windows)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the wx interface shared object files for window 
 opening.

# Package: mgl-lua
# Architecture: any
# Section: libs
# Depends: ${shlibs:Depends}, ${misc:Depends}, libmgl-data
# Description: library for scientific graphs (Lua interface)
#  A free cross-platform library of fast C++ routines for plotting data in up
#  to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
#  files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
#  MathGL can also be used in the console. There are interfaces to a set of
#  languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
#  .
#  This package contains the Lua interface shared object files.

Package: libmgl-data
Architecture: all
Multi-Arch: foreign
Section: misc
Depends: ${misc:Depends}
Description: library for scientific graphs (data files)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the MathGL data files.

Package: libmgl-dev
Architecture: any
Section: libdevel
Depends: libmgl7.5.0 (= ${binary:Version}), libmgl-wnd7.5.0 (= ${binary:Version}),
 libmgl-wx7.5.0 (= ${binary:Version}), libmgl-fltk7.5.0 (= ${binary:Version}),
 libmgl-qt5-7.5.0 (= ${binary:Version}), libmgl-glut7.5.0 (= ${binary:Version}),
 libmgl-mpi7.5.0 (= ${binary:Version}), ${misc:Depends}, libgsl-dev, 
 libgl1-mesa-dev | libgl-dev, libpng-dev
Description: library for scientific graphs (development files)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package contains the development files. 

Package: python3-mathgl
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3,
 python3-numpy
Description: library for scientific graphs (Python module)
 A free cross-platform library of fast C++ routines for plotting data in up
 to 3 dimensions. It can export plots to bitmaps and vector EPS, SVG, IDTF
 files. There are simple window interfaces based on GLUT, FLTK and/or Qt.
 MathGL can also be used in the console. There are interfaces to a set of
 languages, such as, C, Fortran, Pascal, Forth, Python, Octave.
 .
 This package provides the Python v.3 module for mathgl.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v

CXXFLAGS:= $(filter-out -Werror=format-security, $(shell dpkg-buildflags --get CXXFLAGS))

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND = -g0
endif

DOTTED:=`py3versions -d  |  sed 's/python//' `
NODOT:=`py3versions -d | sed 's/\.//' | sed 's/python//' `

%:
	dh $@ --buildsystem=cmake 

override_dh_auto_configure:
	dh_auto_configure -- \
		-DPY3VERSION_DOTTED=$(DOTTED) -DPY3VERSION_NODOT=$(NODOT)	

override_dh_python3:
	dh_numpy3

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel alpha))
override_dh_dwz:
	@echo bypass dwz that causes build failues
endif

=== debian/watch ===
version=3
http://sf.net/mathgl/mathgl-(.*)\.t(?:ar\.)?gz
